;;; -*- Mode: LISP; Syntax: Common-lisp -*-

"(c) Copyright 1986 Xerox Corporation.  All rights reserved.  Subject to
the following conditions, permission is granted to use and copy this
software and to prepare derivative works:  Such use, copying or
preparation of derivative works must be for non-commercial research or
educational purposes; each copy or derivative work must include this
copyright notice in full; a copy of each completed derivative work must
be returned to:  DEKLEER@XEROX.COM (Arpanet) or Johan de Kleer,
Xerox PARC, 3333 Coyote Hill Road, Palo Alto, CA 94304.  This software
is made available AS IS, and Xerox Corporation makes no warranty about
the software or its performance."

;;; The Assumption-Based TMS

;;; Needed because brain-damaged ZL otherwise puts it under zl's global.
#+Symbolics
(in-package 'tms :use '(Common-Lisp))
#-Symbolics
(in-package 'tms :use '(lisp))

;;; Gregor-defsystem spec by KDF

(pcl::defsystem tms
  #+:UIUC
  "rube:>atms>v21>"				
  #+:KDF-RT
  "/u/atms/v21/"
  #+:QRG-RT
  "/u/forbus/code/atms/v21/"
  #+PARC 
  "bd:>atms>v21>"
  #+JOHAN
  "calvin:>atms>v21>"
  ((walk () () ())
   (defs  (walk) () ())
   (user (defs) (defs) (defs))
   (replay (defs) (defs user) (defs user))
   (vector (replay) (defs user replay) (defs user))
   (blists (vector) (defs user vector replay) (defs user replay vector))
   (batms3 (blists) (defs user vector replay blists) (defs user vector blists))
   (hash (batms3) (defs user vector replay batms3) (defs user vector blists))
   (tms7 (hash) (defs user blists hash batms3) (defs user vector blists))
   (interp (tms7) (defs user tms7) (defs user vector blists hash tms7))
   (cons3 (interp) (defs user interp) (defs user vector blists hash tms7))
   (nml (cons3) (defs user cons3) (defs user vector blists cons3 hash tms7))
   (tree (cons3) (defs user nml) (defs user vector blists hash tms7))
   (label (nml) (defs user tree) (defs user vector blists tree hash tms7))
   (examples (label) (defs user label) (defs user vector blists tree hash tms7))
   (diags (examples) (defs user examples) (defs user vector blists tree))
   (patch (batms3) (defs user vector replay batms3) (defs user vector blists))))

(defun compile-atms ()
 (pcl::operate-on-system 'tms :compile))

(defun recompile-atms ()
 (pcl::operate-on-system 'tms :recompile))

(defun load-atms ()
  (pcl::operate-on-system 'tms :load))
